module XpRubyClient
  class Configurator
    ASSIGN_URL_PATH = "/assigner/application/"
    DEFAULT_TIMEOUT = 100

    class NotSetError < StandardError; end

    attr_accessor :application, :segments, :assigned, :timeout

    def initialize(&block)
      @segments = {}
      @assigned = []

      block.call(self)

      @timeout = DEFAULT_TIMEOUT unless timeout
      raise(NotSetError, "'application' must be set") unless @application
    end

    def base_url
      @base_url ||= URI.join(host, ASSIGN_URL_PATH, @application).to_s
    end

    def to_h
      {segments: @segments,
       assigned: @assigned}
    end

    private

    def host
      ENV.fetch("XP_RUBY_CLIENT_HOST")
    end
  end
end
