require "json"
require "patron"

module XpRubyClient
  class Requester
    def initialize(conn)
      @sess = Patron::Session.new do |patron|
        patron.timeout = 30
        patron.base_url = conn.base_url
        patron.headers = {"User-Agent" => "XpRubyClient",
                          "Content-Type" => "application/json"}
      end
      # @sess.enable_debug "/tmp/patron.debug"
      build_payload(conn.to_h)
    end

    def build_payload(segments: {}, assigned: [], **)
      # TODO: log not used arguemnts
      @payload = JSON.dump({segments: segments, assigned: assigned})
    end

    def retrieve(req_payload = nil)
      build_payload(req_payload) if req_payload
      resp = @sess.post("/experiments", @payload)
      parse_body(resp)
    end

    private

    def parse_body(resp)
      JSON.parse(resp.body) if resp.status < 400
      # we don't wat to panic anyhow, so always return nil
      # TODO: log it and/or send to an error catcher
    rescue => e
      nil
    end
  end
end
